#include "func.h"

/*!
\file func.c
\brief troublesome source code

This file contains example software for a bug. It is possibly related the
previously submitted bug #143250.
*/

/*!
\brief ok function declaration

Doxygen understands this function's declaration.

\return pointer to double
*/

double *func3(
    const double a[3],		/* input operand vector */
    const double b[3],		/* input operand vector */
    double c[3])		/* output result vector */
{
    /* ... */
    return 0;
    }

/*!
\brief troublesome function declaration

This function's declaration gives Doxygen heartburn. The return value is a
pointer to a 3-element array of doubles, not just to a double as Doxygen
generates in the documentation. Note the missing leading "(", function
arguments, and trailing ")[3]" in the detailed documentation, and also the
inclusion of trailing text in the function list above. If you comment out the
following funcd function, then no output at all will be generated for func33.

\return pointer to 3-element array of doubles
*/

double (*func33(
    double a[3][3],		/*!< input operand matrix */
    double b[3][3],		/*!< input operand matrix */
    double c[3][3]		/*!< output result matrix */
    ))[3]
{
    /* ... */
    return 0;
    }

double funcd(
    double a[3][3],		/*!< input operand matrix */
    double b[3][3]		/*!< input operand matrix */
    )
{
    /* ... */
    return 0;
    }
